/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Ian Thomas, ian@ithomas.name, original author
   - 
*/


var ds;
var RDF;

function getResults(data_url) {
//	alert('getting ' + data_url);

// This is the object that will observe the RDF/XML load's progress 
	var Observer = { 
		onBeginLoad: function(aSink) {},
		onInterrupt: function(aSink) {}, 
		onResume: function(aSink) {}, 
		onEndLoad: function(aSink) { 
			//document.getElementById('content-tabbrowser').loadURI('chrome://bugxula/content/results.xul?'+data_url);
			populateResults(data_url); 
		}, 
		onError: function(aSink, aStatus, aErrorMsg) { alert("error! " + aErrorMsg); } 
	}; 
	
	// Get the RDF service 
	RDF = Components 
		.classes["@mozilla.org/rdf/rdf-service;1"] 
		.getService(Components.interfaces.nsIRDFService); 
	ds = RDF.GetDataSource(data_url);
	
	// Now see if it's loaded or not... 
	var remote = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource); 
	if (remote.loaded) {
		populateResults(data_url);
	} 
	else { 
		//alert("the datasource wasn't loaded, but it's loading now!"); 

		// RDF/XML Datasources are all nsIRDFXMLSinks  
		var sink = ds.QueryInterface(Components.interfaces.nsIRDFXMLSink);  
		
		// Attach the observer to the datasource-as-sink  
		sink.addXMLSinkObserver(Observer);  
		// Now Observer's methods will be called-back as 
		// the load progresses. 
	}
}

function populateResults(data_source_url) {
//	alert('adding rows');
	var root_node = RDF.GetResource(data_source_url);
	var predicate = RDF.GetResource('http://www.bugzilla.org/rdf#bugs');

	var bugs_node = ds.GetTarget(root_node,predicate,true);
	var targets = ds.ArcLabelsOut(bugs_node);
	while (targets.hasMoreElements()) {
		bug_node = targets.getNext();
		bug = ds.GetTarget(bugs_node,bug_node,true);
		addBugRow(bug);
    }
    decrementProgressMeter();
}

function addBugRow(bug) {
	if (bug.QueryInterface(Components.interfaces.nsIRDFResource).Value != 'http://www.w3.org/1999/02/22-rdf-syntax-ns#Seq') {
		var bugItem = document.createElement('treeitem');
		bugItem.setAttribute('uri',bug.QueryInterface(Components.interfaces.nsIRDFResource).Value);
		var bugRow = document.createElement('treerow');
			
			// Each of the following blocks will get the data for one property and add it to the current row.
			var bug_property;
			
			// Installation name, passed as a variable
		/*	var bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','installation_column');
			bugCell.setAttribute('label',installation);
			bugRow.appendChild(bugCell);*/
			
			// Bug ID#
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#id'),true);
			bug_property instanceof Components.interfaces.nsIRDFInt;
		  	var bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','id_column');
			//alert('Adding bug #' + bug_property.Value);
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			bugItem.setAttribute('onselect','alert("Bug selected"); loadBugInContentPane(' + bug_property.Value + ');\'');
			
			// Bug severity
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#bug_severity'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','severity_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
			// Bug priority
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#priority'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','priority_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
			// Bug platform
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#rep_platform'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','platform_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
			// Owner
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#assigned_to'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','owner_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
			// Status
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#bug_status'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','status_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
			// Resolution
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#resolution'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','resolution_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
			// Description
			bug_property = ds.GetTarget(bug,RDF.GetResource('http://www.bugzilla.org/rdf#short_short_desc'),true);
			bug_property instanceof Components.interfaces.nsIRDFLiteral;
		  	bugCell = document.createElement('treecell');
			bugCell.setAttribute('ref','summary_column');
			if (bug_property) {
				bugCell.setAttribute('label',bug_property.Value);
			}
			else {
				bugCell.setAttribute('label','-');
			}
			bugRow.appendChild(bugCell);
			
		// Add the complete row to the tree	
		bugItem.appendChild(bugRow);
		document.getElementById('results-tree-children').appendChild(bugItem);
	}
}

function loadBug(url, canOpenBrowser)
{
  // Loads a bug in the content pane if it's visible; otherwise loads it
  // in a browser window if enabled.
  
  // Opening a closed splitter by dragging it rather than by clicking 
  // its grippy puts it into the "" state instead of the "open" state.
  // I'm not sure why that is, but as far as I can tell only open splitters
  // are ever in this empty state, so I equate this state with "open".
  var splitter = document.getElementById('results-content-splitter');
  var state = splitter.getAttribute('state');
  if (state == 'open' || state == '')
  {
    var bugPane = document.getElementById('bug-pane');
    bugPane.setAttribute('src', url);
  }
  else if (canOpenBrowser) {
    loadURLInBrowser(url);
  }
}

function loadBugInContentPane()
{
  // Loads the bug selected in the results pane into Bugxula's content pane 
  // if the pane is visible.
  
 // var index = tree.currentIndex;
 // alert(tree + ', Position: ' + index);
 // alert('Treeview: ' + treeview);
 // treeitem = treeview.getItemAtIndex(index);
 // alert('Item: ' + treeitem);
 // alert('Cell Text: ' + selected_bug);
  
 /* boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
  var var1,var2,var3;
  boxobject.getCellAt(1,1,var1,var2,var3);
  alert(var1 + "," + var2 + "," + var3);*/
  /*alert(tree.view.getCellText(index,'id_column'));
  var builder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
  alert(builder);*/
 // var resource = builder.getResourceAtIndex(index);
 // var bugURL = resource.Value;
  var tree = document.getElementById('results-tree');  
  var treeview = tree.view;
  treeview instanceof Components.interfaces.nsITreeView;
  var selected_bug = treeview.getCellText(tree.currentIndex,tree.columns.getNamedColumn('id_column'));
  loadBug('https://bugzilla.mozilla.org/show_bug.cgi?id=' + selected_bug, false);
}

function loadBugInBrowser()
{
 /* var tree = document.getElementById('results-tree');
  var index = tree.currentIndex;
  var builder = tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
  var resource = builder.getResourceAtIndex(index);
  var bugURL = resource.Value;
  loadURLInBrowser(bugURL);*/
  var tree = document.getElementById('results-tree');  
  var treeview = tree.view;
  treeview instanceof Components.interfaces.nsITreeView;
  var selected_bug = treeview.getCellText(tree.currentIndex,tree.columns.getNamedColumn('id_column'));
  loadURLInBrowser('https://bugzilla.mozilla.org/show_bug.cgi?id=' + selected_bug);
}